# This tasks create an alternative backup schedule based on the current gitlab-toolbox-backup cronjob, as it' isn't possible to define more than 1 backup schedule via the helm chart

- set_fact: 
    cronjob_file_path: "{{ install_dir }}/gitlab/alternative_backup_cronjob.yml"

- name: Get toolbox backup cronjob
  shell: kubectl get cronjob/gitlab-toolbox-backup -n "{{ config.gitlab.namespace }}" -o yaml > "{{ cronjob_file_path }}"

- name: Remove lines in file
  lineinfile:
    path: "{{ cronjob_file_path }}"
    regexp: "{{ item }}"
    state: absent
  with_items:
    - 'creationTimestamp'
    - 'resourceVersion'
    - 'selfLink'
    - 'uid'
    - 'successfulJobsHistoryLimit'
    - 'status'
    - 'lastScheduleTime'

- name: Replace name
  lineinfile:
    path: "{{ cronjob_file_path }}"
    regexp: 'name: gitlab-toolbox-backup'
    line: "{{ 'name: alternative-gitlab-toolbox-backup' | indent( width=2, indentfirst=True) }}"

- name: Replace backup command
  lineinfile:
    path: "{{ cronjob_file_path }}"
    regexp: 'backup-utility'
    line: "{{ backup_arguments | indent( width=12, indentfirst=True) }}"
  vars: 
    backup_arguments: "- cp /etc/gitlab/.s3cfg $HOME/.s3cfg && backup-utility {{ config.gitlab.alternative_backup_cronjob.arguments }}"
    # Valid config.gitlab.alternative_backup_cronjob.arguments are: 
    # '--skip artifacts' or:
    # '--skip artifacts --skip registry --skip db --skip lfs' or
    # '--skip artifacts --skip registry' etc.

- name: Replace schedule
  lineinfile:
    path: "{{ cronjob_file_path }}"
    regexp: 'schedule'
    line: "{{ backup_schedule | indent( width=2, indentfirst=True) }}"
  vars:
    backup_schedule: "schedule: {{ config.gitlab.alternative_backup_cronjob.schedule }}"

- name: Create cronjob 
  k8s:
    src: "{{ cronjob_file_path }}"
    state: present
    apply: yes 
